/* tslint:disable */
/* eslint-disable */
/**
 * Golemio COVID-19 Prague API
 * API for multiple reservation system for samling points of COVID19
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { SamplingPointsServiceProcessTypeEnum, SamplingPointsServiceQueueTypeEnum, SamplingPointsServiceRequestTypeEnum } from 'api';
import { exists, mapValues } from '../runtime';
import {
    SamplingPointsServicesOpeningHours,
    SamplingPointsServicesOpeningHoursFromJSON,
    SamplingPointsServicesOpeningHoursFromJSONTyped,
    SamplingPointsServicesOpeningHoursToJSON,
    SamplingPointsServicesQueue,
    SamplingPointsServicesQueueFromJSON,
    SamplingPointsServicesQueueFromJSONTyped,
    SamplingPointsServicesQueueToJSON,
    SamplingPointsServicesRs,
    SamplingPointsServicesRsFromJSON,
    SamplingPointsServicesRsFromJSONTyped,
    SamplingPointsServicesRsToJSON,
} from './';

/**
 * 
 * @export
 * @interface SamplingPointsService
 */
export interface SamplingPointsService {
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    id: number;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    samplingPointsId: number;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    title?: string;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    type: string;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    price: number;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    currency: string;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    note?: string | null;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    samplingPointsServicesRsId?: number | null;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    resultTimeHours: number;
    /**
     * 
     * @type {boolean}
     * @memberof SamplingPointsService
     */
    certificate: boolean;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    certificatePrice?: number | null;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    certificateCurrency: string;
    /**
     * 
     * @type {number}
     * @memberof SamplingPointsService
     */
    samplingPointsServicesOpeninghoursSetId: number;
    /**
     * 
     * @type {Date}
     * @memberof SamplingPointsService
     */
    updatedAt: Date;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    requestType?: SamplingPointsServiceRequestTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    queueType?: SamplingPointsServiceQueueTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    processType?: SamplingPointsServiceProcessTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    status: SamplingPointsServiceStatusEnum;
    /**
     * 
     * @type {Array<SamplingPointsServicesOpeningHours>}
     * @memberof SamplingPointsService
     */
    openingHours?: Array<SamplingPointsServicesOpeningHours> | null;
    /**
     * 
     * @type {SamplingPointsServicesRs}
     * @memberof SamplingPointsService
     */
    rs?: SamplingPointsServicesRs | null;
    /**
     * 
     * @type {SamplingPointsServicesQueue}
     * @memberof SamplingPointsService
     */
    queue?: SamplingPointsServicesQueue | null;
    /**
     * 
     * @type {string}
     * @memberof SamplingPointsService
     */
    link?: string | null;
    /**
     * Used only if the request contains some filter query parameter, e.g. `/samplingpoints?district=CelaPraha`.
     * @type {boolean}
     * @memberof SamplingPointsService
     */
    filterMatched?: boolean | null;
}

export function SamplingPointsServiceFromJSON(json: any): SamplingPointsService {
    return SamplingPointsServiceFromJSONTyped(json, false);
}

export function SamplingPointsServiceFromJSONTyped(json: any, ignoreDiscriminator: boolean): SamplingPointsService {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'id': json['id'],
        'samplingPointsId': json['sampling_points_id'],
        'title': !exists(json, 'title') ? undefined : json['title'],
        'type': json['type'],
        'price': json['price'],
        'currency': json['currency'],
        'note': !exists(json, 'note') ? undefined : json['note'],
        'samplingPointsServicesRsId': !exists(json, 'sampling_points_services_rs_id') ? undefined : json['sampling_points_services_rs_id'],
        'resultTimeHours': json['result_time_hours'],
        'certificate': json['certificate'],
        'certificatePrice': !exists(json, 'certificate_price') ? undefined : json['certificate_price'],
        'certificateCurrency': json['certificate_currency'],
        'samplingPointsServicesOpeninghoursSetId': json['sampling_points_services_openinghours_set_id'],
        'updatedAt': (new Date(json['updated_at'])),
        'requestType': !exists(json, 'request_type') ? undefined : json['request_type'],
        'queueType': !exists(json, 'queue_type') ? undefined : json['queue_type'],
        'processType': !exists(json, 'process_type') ? undefined : json['process_type'],
        'status': json['status'],
        'openingHours': !exists(json, 'openingHours') ? undefined : (json['openingHours'] === null ? null : (json['openingHours'] as Array<any>).map(SamplingPointsServicesOpeningHoursFromJSON)),
        'rs': !exists(json, 'rs') ? undefined : SamplingPointsServicesRsFromJSON(json['rs']),
        'queue': !exists(json, 'queue') ? undefined : SamplingPointsServicesQueueFromJSON(json['queue']),
        'link': !exists(json, 'link') ? undefined : json['link'],
        'filterMatched': !exists(json, 'filter_matched') ? undefined : json['filter_matched'],
    };
}

export function SamplingPointsServiceToJSON(value?: SamplingPointsService | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'id': value.id,
        'sampling_points_id': value.samplingPointsId,
        'title': value.title,
        'type': value.type,
        'price': value.price,
        'currency': value.currency,
        'note': value.note,
        'sampling_points_services_rs_id': value.samplingPointsServicesRsId,
        'result_time_hours': value.resultTimeHours,
        'certificate': value.certificate,
        'certificate_price': value.certificatePrice,
        'certificate_currency': value.certificateCurrency,
        'sampling_points_services_openinghours_set_id': value.samplingPointsServicesOpeninghoursSetId,
        'updated_at': (value.updatedAt.toISOString()),
        'request_type': value.requestType,
        'queue_type': value.queueType,
        'process_type': value.processType,
        'status': value.status,
        'openingHours': value.openingHours === undefined ? undefined : (value.openingHours === null ? null : (value.openingHours as Array<any>).map(SamplingPointsServicesOpeningHoursToJSON)),
        'rs': SamplingPointsServicesRsToJSON(value.rs),
        'queue': SamplingPointsServicesQueueToJSON(value.queue),
        'link': value.link,
        'filter_matched': value.filterMatched,
    };
}

/**
* @export
* @enum {string}
*/
export enum SamplingPointsServiceStatusEnum {
    Active = 'active'
}


